%define version 2.0.16
%define release %mkrel 1

Summary:	Stack Overflow protection
Name:		libsafe
Version:	%{version}
Release:	%{release}
Source:		libsafe-2.0-16.tgz
License:	LGPL
Group:		System/Libraries
BuildRoot:	%{_tmppath}/libsafe
ExclusiveArch:	%ix86
URL: http://www.research.avayalabs.com/project/libsafe/

%description
The libsafe library is designed to overwrite dangerous
library C function like strcpy / snprintf and perform
bound checking on the destination buffer address in order
to detect an eventual Stack Overflow attempt.

The libsafe library protects a process against the exploitation of buffer
overflow vulnerabilities in process stacks. Libsafe works with any
existing pre-compiled executable and can be used transparently, even on a
system-wide basis. The method intercepts all calls to library functions
that are known to be vulnerable. A substitute version of the corresponding
function implements the original functionality, but in a manner that
ensures that any buffer overflows are contained within the current stack
frame. Libsafe has been shown to detect several known attacks and can
potentially prevent yet unknown attacks. Experiments indicate that the
performance overhead of libsafe is negligible.

%prep 
%setup -q -n %{name}-2.0-16

%build
# Do not use the Mandrake compilation flags,
# this library must not be compiled without any optimizations flags...
make libsafe

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
#problem with ldconfig in makefile cannot make install without patch
#make install LIBDIR=$RPM_BUILD_ROOT/lib LIBDIR=$RPM_BUILD_ROOT/%{_mandir} 
rm -f exploits/xlock

install -d $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 doc/libsafe.8 $RPM_BUILD_ROOT%{_mandir}/man8/
install -d $RPM_BUILD_ROOT/lib
install -m 644 src/libsafe.so.%{version} $RPM_BUILD_ROOT/lib
cd $RPM_BUILD_ROOT/lib
ln -s libsafe.so.%{version} libsafe.so.`echo %{version} | cut -d. -f1`

%post
tmpfile=`mktemp /tmp/libsafe.XXXXXX`
cp /etc/sysconfig/system $tmpfile
grep -v LIBSAFE $tmpfile > /etc/sysconfig/system
echo "LIBSAFE=yes" >> /etc/sysconfig/system

if [ -f /etc/ld.so.preload ]; then
  if grep -q libsafe /etc/ld.so.preload 2>/dev/null; then

	echo "Updating path to libsafe in /etc/ld.so.preload"
	cp /etc/ld.so.preload $tmpfile
	grep -v libsafe < $tmpfile > /etc/ld.so.preload
	echo /lib/libsafe.so.2 >> /etc/ld.so.preload

  fi
fi

rm -f $tmpfile

%preun
tmpfile=`mktemp /tmp/libsafe.XXXXXX`
cp /etc/sysconfig/system $tmpfile
grep -v LIBSAFE $tmpfile > /etc/sysconfig/system

if [ -f /etc/ld.so.preload ]; then
  if grep -q libsafe /etc/ld.so.preload 2>/dev/null; then

    echo "Removing libsafe from /etc/ld.so.preload"
	cp /etc/ld.so.preload $tmpfile
	grep -v libsafe < $tmpfile > /etc/ld.so.preload
  fi
fi

rm -f $tmpfile



%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc doc/* exploits
/lib/*
%{_mandir}/*/*


%changelog
* Thu Nov 16 2006 Neverstopdreaming <neverstopdreaming@gmail.com> 2.0.13-4pclos2007
- Build for PCLinuxOS 2007

* Thu Nov 16 2006 Neverstopdreaming <neverstopdreaming@gmail.com> 2.0.16-1pclos2007
- new release
